# --- SDE-COPYRIGHT-NOTE-BEGIN ---
# This copyright note is auto-generated by ./scripts/Create-CopyPatch.
#
# Filename: package/.../linux/arch/config-common.sh
# Copyright (C) 2008 - 2012 The OpenSDE Project
#
# More information can be found in the files COPYING and README.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License. A copy of the
# GNU General Public License can be found in the file COPYING.
# --- SDE-COPYRIGHT-NOTE-END ---

linux_ver="$1"

cat <<EOT
# don't add a fancy hash at the end of the kernel version
CONFIG_LOCALVERSION_AUTO=n

# it's fanciness, but everyone likes it there by default, FB and the pinguins
CONFIG_FB=y
CONFIG_FRAMEBUFFER_CONSOLE=y
CONFIG_LOGO=y

# serial console
CONFIG_SERIAL_8250=y
CONFIG_SERIAL_8250_CONSOLE=y
CONFIG_SERIAL_8250_PCI=y
CONFIG_SERIAL_8250_PNP=y

# ps/2 keyboard & mouse - as of 2.6.27, it can't be handled by udev
CONFIG_SERIO=y
CONFIG_SERIO_I8042=y

# udev needs it built-in
CONFIG_UNIX=y

# recommended by udev (as of 136)
CONFIG_SYSFS_DEPRECATED=n
CONFIG_SYSFS_DEPRECATED_V2=n

# no debugging by default
CONFIG_DEBUG_.*=n
CONFIG_.*_DEBUG=n
CONFIG_REISERFS_CHECK=n

# disable /dev/kmem by default (besides by rootkits it is used very rarely)
# https://lkml.org/lkml/2008/2/10/328
CONFIG_DEVKMEM=n

# disable gcov kernel profiling support because it seems to be broken
CONFIG_GCOV_KERNEL=n
CONFIG_GCOV_PROFILE_ALL=n

# disable the tracing infrastructure by default
CONFIG_FTRACE=n

# disable build time boot arguments by default
CONFIG_CMDLINE_BOOL=n

# disable sample code
CONFIG_SAMPLES=n

# do not refuse to enumerate external hubs
CONFIG_USB_OTG_BLACKLIST_HUB=n
EOT

# broken since 2.6.20 and still as of 2.6.27
echo "CONFIG_SUNDANCE_MMIO=n"
