# --- SDE-COPYRIGHT-NOTE-BEGIN ---
# This copyright note is auto-generated by ./scripts/Create-CopyPatch.
#
# Filename: package/.../linux/arch/config.x86-64.sh
# Copyright (C) 2008 The OpenSDE Project
#
# More information can be found in the files COPYING and README.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License. A copy of the
# GNU General Public License can be found in the file COPYING.
# --- SDE-COPYRIGHT-NOTE-END ---

# we will ignore the linux version for now, returning the same for all
linux_ver="$1"

# Map $SDECFG_X8664_OPT to something meaningful to the kernel
linux_arch_map="k8:MK8
opteron:MK8
athlon64:MK8
athlon-fx:MK8
em64t:MPSC"

linux_arch=
for x in $linux_arch_map; do
	if [ "$SDECFG_X8664_OPT" = "${x%:*}" ]; then
		linux_arch="${x#*:}"
		break
	fi
done

# we only want to inject it once
for x in $( echo "$linux_arch_map" | cut -d: -f2 | sort -u ); do
	if [ "$linux_arch" = "$x" ]; then
		echo "CONFIG_$x=y"
	else
		echo "# CONFIG_$x is not set"
	fi
done

# and as a fallback, GENERIC_CPU
if [ -z "$linux_arch" ]; then
	echo "CONFIG_GENERIC_CPU=y"
else
	echo "# CONFIG_GENERIC_CPU is not set"
fi

exec sh ${0%/*}/config-common.sh "$linux_ver"
