# --- SDE-COPYRIGHT-NOTE-BEGIN ---
# This copyright note is auto-generated by ./scripts/Create-CopyPatch.
#
# Filename: package/.../linux/arch/config.x86.sh
# Copyright (C) 2008 The OpenSDE Project
#
# More information can be found in the files COPYING and README.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License. A copy of the
# GNU General Public License can be found in the file COPYING.
# --- SDE-COPYRIGHT-NOTE-END ---

lx_ver="$1"

# Map $SDECFG_X86_OPT to something meaningful to the kernel
linux_arch_map="i386:M386
i486:M486
c3:MCYRIXIII
c3-2:MVIAC3_2
pentium:M586
pentium-mmx:M586MMX
pentiumpro:M686
pentium2:MPENTIUMII
pentium3:MPENTIUMIII
pentium4:MPENTIUM4
pentium-m:MPENTIUMM
k6:MK6
k6-2:MK6
k6-3:MK6
athlon:MK7
athlon-tbird:MK7
athlon4:MK7
athlon-xp:MK7
athlon-mp:MK7C"

linux_arch="M386"
for x in $linux_arch_map; do
	if [ "$SDECFG_X86_OPT" = "${x%:*}" ]; then
		linux_arch="${x#*:}"
		break
	fi
done

# we only want to inject it once
for x in $( echo "$linux_arch_map" | cut -d: -f2 | sort -u ); do
	if [ "$linux_arch" = "$x" ]; then
		echo "CONFIG_$x=y"
	else
		echo "# CONFIG_$x is not set"
	fi
done

if [ $lx_ver -ge 2006024 ]; then
	# Merged i386 and x86-64
	echo "CONFIG_64BIT=n"
else
	cat <<-EOT
	CONFIG_X86_GENERIC=y
	CONFIG_X86_PC=y

	EOT
fi

exec sh ${0%/*}/config-common.sh "$lx_ver"
