#!/bin/sh
# --- SDE-COPYRIGHT-NOTE-BEGIN ---
# This copyright note is auto-generated by ./scripts/Create-CopyPatch.
#
# Filename: package/.../udev/create_nodes.sh
# Copyright (C) 2008 The OpenSDE Project
#
# More information can be found in the files COPYING and README.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License. A copy of the
# GNU General Public License can be found in the file COPYING.
# --- SDE-COPYRIGHT-NOTE-END ---

cd "${1:-.}"

while read type node mode uid gid data; do
	[ -n "$type" ] || continue
	expr "$type" : '#' > /dev/null && continue

	case "$type" in
	c|s)
		rm -f "$node"
		;;
	esac

	case "$type" in
	d)
		mkdir -v "$node"
		;;
	l)
		ln -snvf "$data" "$node"
		 ;;
	c)
		echo "mknod: Creating $node c $data" >&2
		mknod "$node" c $data
		;;
	s)
		echo "mkfifo: Creating $node" >&2
		mkfifo "$node"
		;;
	esac

	case "$type" in
	l)
		;;
	*)
		chmod "$mode" "$node"
		chown "$uid:$gid" "$node"
		;;
	esac

	echo "$PWD/$node"
done

